/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(STREAMS_API)

#include "JSReadableStream.h"

#include "JSDOMBinding.h"
#include "ReadableStream.h"
#include "ScriptExecutionContext.h"
#include <runtime/Error.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionRead(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionCancel(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionPipeTo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionPipeThrough(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsReadableStreamState(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsReadableStreamClosed(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsReadableStreamReady(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsReadableStreamConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSReadableStreamPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSReadableStreamPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSReadableStreamPrototype* ptr = new (NotNull, JSC::allocateCell<JSReadableStreamPrototype>(vm.heap)) JSReadableStreamPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSReadableStreamPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

class JSReadableStreamConstructor : public DOMConstructorObject {
private:
    JSReadableStreamConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSReadableStreamConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSReadableStreamConstructor* ptr = new (NotNull, JSC::allocateCell<JSReadableStreamConstructor>(vm.heap)) JSReadableStreamConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
    static JSC::ConstructType getConstructData(JSC::JSCell*, JSC::ConstructData&);
};

/* Hash table */

static const struct CompactHashIndex JSReadableStreamTableIndex[4] = {
    { -1, -1 },
    { 0, -1 },
    { 1, -1 },
    { -1, -1 },
};


static const HashTableValue JSReadableStreamTableValues[] =
{
    { "closed", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsReadableStreamClosed), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "ready", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsReadableStreamReady), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

static const HashTable JSReadableStreamTable = { 2, 3, true, JSReadableStreamTableValues, 0, JSReadableStreamTableIndex };
const ClassInfo JSReadableStreamConstructor::s_info = { "ReadableStreamConstructor", &Base::s_info, 0, CREATE_METHOD_TABLE(JSReadableStreamConstructor) };

JSReadableStreamConstructor::JSReadableStreamConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSReadableStreamConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSReadableStream::getPrototype(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontDelete | DontEnum);
}

ConstructType JSReadableStreamConstructor::getConstructData(JSCell*, ConstructData& constructData)
{
    constructData.native.function = constructJSReadableStream;
    return ConstructTypeHost;
}

/* Hash table for prototype */

static const HashTableValue JSReadableStreamPrototypeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsReadableStreamConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "state", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsReadableStreamState), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "read", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsReadableStreamPrototypeFunctionRead), (intptr_t) (0) },
    { "cancel", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsReadableStreamPrototypeFunctionCancel), (intptr_t) (1) },
    { "pipeTo", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsReadableStreamPrototypeFunctionPipeTo), (intptr_t) (2) },
    { "pipeThrough", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsReadableStreamPrototypeFunctionPipeThrough), (intptr_t) (2) },
};

WEBCORE_EXPORT const ClassInfo JSReadableStreamPrototype::s_info = { "ReadableStreamPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSReadableStreamPrototype) };

void JSReadableStreamPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSReadableStreamPrototypeTableValues, *this);
}

WEBCORE_EXPORT const ClassInfo JSReadableStream::s_info = { "ReadableStream", &Base::s_info, &JSReadableStreamTable, CREATE_METHOD_TABLE(JSReadableStream) };

JSReadableStream::JSReadableStream(Structure* structure, JSDOMGlobalObject* globalObject, Ref<ReadableStream>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSReadableStream::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSReadableStreamPrototype::create(vm, globalObject, JSReadableStreamPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSReadableStream::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSReadableStream>(vm, globalObject);
}

void JSReadableStream::destroy(JSC::JSCell* cell)
{
    JSReadableStream* thisObject = static_cast<JSReadableStream*>(cell);
    thisObject->JSReadableStream::~JSReadableStream();
}

JSReadableStream::~JSReadableStream()
{
    releaseImplIfNotNull();
}

bool JSReadableStream::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSReadableStream* thisObject = jsCast<JSReadableStream*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSReadableStream, Base>(exec, JSReadableStreamTable, thisObject, propertyName, slot);
}

EncodedJSValue jsReadableStreamState(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSReadableStream* castedThis = jsDynamicCast<JSReadableStream*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSReadableStreamPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "ReadableStream", "state");
        return throwGetterTypeError(*exec, "ReadableStream", "state");
    }
    ReadableStream& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.state());
    return JSValue::encode(result);
}


EncodedJSValue jsReadableStreamClosed(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSReadableStream* castedThis = jsCast<JSReadableStream*>(slotBase);
    return JSValue::encode(castedThis->closed(exec));
}


EncodedJSValue jsReadableStreamReady(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSReadableStream* castedThis = jsCast<JSReadableStream*>(slotBase);
    return JSValue::encode(castedThis->ready(exec));
}


EncodedJSValue jsReadableStreamConstructor(ExecState* exec, JSObject* baseValue, EncodedJSValue, PropertyName)
{
    JSReadableStreamPrototype* domObject = jsDynamicCast<JSReadableStreamPrototype*>(baseValue);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSReadableStream::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSReadableStream::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSReadableStreamConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionRead(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSReadableStream* castedThis = jsDynamicCast<JSReadableStream*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "ReadableStream", "read");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSReadableStream::info());
    return JSValue::encode(castedThis->read(exec));
}

EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionCancel(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSReadableStream* castedThis = jsDynamicCast<JSReadableStream*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "ReadableStream", "cancel");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSReadableStream::info());
    return JSValue::encode(castedThis->cancel(exec));
}

EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionPipeTo(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSReadableStream* castedThis = jsDynamicCast<JSReadableStream*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "ReadableStream", "pipeTo");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSReadableStream::info());
    return JSValue::encode(castedThis->pipeTo(exec));
}

EncodedJSValue JSC_HOST_CALL jsReadableStreamPrototypeFunctionPipeThrough(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSReadableStream* castedThis = jsDynamicCast<JSReadableStream*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "ReadableStream", "pipeThrough");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSReadableStream::info());
    return JSValue::encode(castedThis->pipeThrough(exec));
}

bool JSReadableStreamOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSReadableStreamOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSReadableStream* jsReadableStream = jsCast<JSReadableStream*>(handle.slot()->asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsReadableStream->impl(), jsReadableStream);
    jsReadableStream->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7ReadableStream@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore14ReadableStreamE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, ReadableStream* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSReadableStream>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7ReadableStream@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore14ReadableStreamE[2];
#if COMPILER(CLANG)
    // If this fails ReadableStream does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(ReadableStream), ReadableStream_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // ReadableStream has subclasses. If ReadableStream has subclasses that get passed
    // to toJS() we currently require ReadableStream you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSReadableStream>(globalObject, impl);
}

ReadableStream* JSReadableStream::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSReadableStream*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(STREAMS_API)
